﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class MouseClicker : AThinker
    {

        public MouseClicker()
        {
           
        }

        public override void Update()
        {
            Owner.Collider.Position = MInput.WindowPos();

            if (MInput.IsClicked(SFML.Window.Mouse.Button.Left))
            {
                this.Owner.CanCollide = true;
            }

            else if (MInput.IsReleased(SFML.Window.Mouse.Button.Left))
            {
                this.Owner.CanCollide = false;
            }

            Owner.Collider.Rotate(0.05f);
        }

        public override void Init()
        {
            this.Owner.CanCollide = false;
        }
    }
}
