﻿using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class LinearSlowDownMover : AThinker
    {
        Vector2f start;
        public Vector2f direction;

        public float startSpeed;
        public float speed;


        public LinearSlowDownMover(Vector2f start, Vector2f dir, float speed)
        {
            this.start = start;
            this.direction = dir;
            this.startSpeed = speed;
            this.speed = speed;
            
        }

        public override void Update()
        {
            speed *= 0.97f;
            this.Owner.Collider.Position = this.Owner.Collider.Position + direction * speed;

            if (speed<0.3f)
                Owner.Kill();
        }

        public override void Init()
        {
            this.Owner.Collider.Position = start;
            this.Owner.Collider.Direction = direction;
        }

    }
}
