﻿using BobbleCrowd.Components;
using SFML.Graphics;
using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.GameStates
{
    public class Credits : AGameState
    {
        Sprite acaSprite;
        Text textKai;
        Text textGerd;
        Text aGameBy;
        Text textAcagamics;
        Font font;

        AnimationSprite aniSpriteBody;
        AnimationSprite aniSpriteMouth;
        AnimationSprite aniSpriteEye;

        //#Best Code ever

        AnimationSprite aniSpriteBody2;
        AnimationSprite aniSpriteMouth2;
        AnimationSprite aniSpriteEye2;


        float speed = 1;

        Vector2f names = new Vector2f(30, 40);
        public Credits()
        {
            
        }

        public override void Init(AGameState lastGameState)
        {
            font = new Font(Game.Content.Load<Font>(Strings.FONT_NAME));


            aniSpriteBody = new AnimationSprite("bobble/body/bodySprite.png",100);
            aniSpriteMouth = new AnimationSprite("bobble/mouth/mouthes.png", MathUtil.Rand.Next(3), 3, 100);
            aniSpriteEye = new AnimationSprite("bobble/eye/eyes.png", MathUtil.Rand.Next(3), 3, 100);

            aniSpriteBody.Init();
            aniSpriteEye.Init();
            aniSpriteMouth.Init();


            aniSpriteBody2 = new AnimationSprite("bobble/body/bodySprite.png", 100);
            aniSpriteMouth2 = new AnimationSprite("bobble/mouth/mouthes.png", MathUtil.Rand.Next(3), 3, 100);
            aniSpriteEye2 = new AnimationSprite("bobble/eye/eyes.png", MathUtil.Rand.Next(3), 3, 100);

            aniSpriteBody2.Init();
            aniSpriteEye2.Init();
            aniSpriteMouth2.Init();




            aniSpriteBody2.position = new Vector2f(-500, Settings.WindowSize.Y - 50);
            int a = MathUtil.Rand.Next(3);
            if (a == 0)
                aniSpriteBody2.SetColor(BobbleDraw.BODY_RED);
            if (a == 1)
                aniSpriteBody2.SetColor(BobbleDraw.BODY_GREEN);
            if (a == 2)
                aniSpriteBody2.SetColor(BobbleDraw.BODY_BLUE);

            aniSpriteBody2.scale = 0.6f;
            aniSpriteMouth2.position = new Vector2f(-500, Settings.WindowSize.Y - 50);
            aniSpriteMouth2.scale = 0.6f;
            aniSpriteEye2.position = new Vector2f(-500, Settings.WindowSize.Y - 50);
            aniSpriteEye2.scale = 0.6f;




            aniSpriteBody.position = new Vector2f(-50, Settings.WindowSize.Y - 50);
            a = MathUtil.Rand.Next(3);
            if (a == 0)
                aniSpriteBody.SetColor(BobbleDraw.BODY_RED);
            if (a == 1)
                aniSpriteBody.SetColor(BobbleDraw.BODY_GREEN);
            if (a == 2)
                aniSpriteBody.SetColor(BobbleDraw.BODY_BLUE);

            aniSpriteBody.scale = 0.6f;
            aniSpriteMouth.position = new Vector2f(-50, Settings.WindowSize.Y - 50);
            aniSpriteMouth.scale = 0.6f;
            aniSpriteEye.position = new Vector2f(-50, Settings.WindowSize.Y - 50);
            aniSpriteEye.scale = 0.6f;


            acaSprite = new Sprite(Game.Content.Load<Texture>("gfx/figure.png"));
            acaSprite.Position = new Vector2f(570, 300);
            acaSprite.Scale = new Vector2f(0.5f, 0.5f);

            

            textKai = new Text("Kai Bornemann",font);
            textGerd = new Text("Gerd Schmidt", font);
            textAcagamics = new Text("Acagamics e.V.", font);
            aGameBy = new Text("a game by: ", font);

            aGameBy.Position = new Vector2f(20 + names.X, 10 + names.Y);
            textKai.Position = new Vector2f(80 + names.X, 100 + names.Y);
            textGerd.Position = new Vector2f(80 + names.X, 150 + names.Y);
            textAcagamics.Position = new Vector2f(80 + names.X, 200 + names.Y);
        }

        public override void ShutDown()
        {
            
        }

        public override void Update()
        {
            aniSpriteBody.position += new Vector2f(speed, 0);
            aniSpriteEye.position += new Vector2f(speed, 0);
            aniSpriteMouth.position += new Vector2f(speed, 0);

            aniSpriteBody.Update(parent.gameTime);
            aniSpriteEye.Update(parent.gameTime);
            aniSpriteMouth.Update(parent.gameTime);



            aniSpriteBody2.position += new Vector2f(speed, 0);
            aniSpriteEye2.position += new Vector2f(speed, 0);
            aniSpriteMouth2.position += new Vector2f(speed, 0);

            aniSpriteBody2.Update(parent.gameTime);
            aniSpriteEye2.Update(parent.gameTime);
            aniSpriteMouth2.Update(parent.gameTime);


            if (aniSpriteBody2.position.X > Settings.WindowSize.X + 50)
            {

                aniSpriteBody2 = new AnimationSprite("bobble/body/bodySprite.png", 100);
                aniSpriteMouth2 = new AnimationSprite("bobble/mouth/mouthes.png", MathUtil.Rand.Next(3), 3, 100);
                aniSpriteEye2 = new AnimationSprite("bobble/eye/eyes.png", MathUtil.Rand.Next(3), 3, 100);

                aniSpriteBody2.Init();
                aniSpriteEye2.Init();
                aniSpriteMouth2.Init();

                int a = MathUtil.Rand.Next(3);
                if (a == 0)
                    aniSpriteBody2.SetColor(BobbleDraw.BODY_RED);
                if (a == 1)
                    aniSpriteBody2.SetColor(BobbleDraw.BODY_GREEN);
                if (a == 2)
                    aniSpriteBody2.SetColor(BobbleDraw.BODY_BLUE);




                aniSpriteBody2.position = new Vector2f(-50, Settings.WindowSize.Y - 50);
                aniSpriteMouth2.position = new Vector2f(-50, Settings.WindowSize.Y - 50);
                aniSpriteEye2.position = new Vector2f(-50, Settings.WindowSize.Y - 50);

                aniSpriteBody2.scale = 0.6f;
                aniSpriteMouth2.scale = 0.6f;
                aniSpriteEye2.scale = 0.6f;



            }


            if(aniSpriteBody.position.X> Settings.WindowSize.X+50)
            {

                aniSpriteBody = new AnimationSprite("bobble/body/bodySprite.png", 100);
                aniSpriteMouth = new AnimationSprite("bobble/mouth/mouthes.png", MathUtil.Rand.Next(3), 3, 100);
                aniSpriteEye = new AnimationSprite("bobble/eye/eyes.png", MathUtil.Rand.Next(3), 3, 100);

                aniSpriteBody.Init();
                aniSpriteEye.Init();
                aniSpriteMouth.Init();

                int a = MathUtil.Rand.Next(3);
                if(a ==0)
                    aniSpriteBody.SetColor(BobbleDraw.BODY_RED);
                if (a == 1)
                    aniSpriteBody.SetColor(BobbleDraw.BODY_GREEN);
                if (a == 2)
                    aniSpriteBody.SetColor(BobbleDraw.BODY_BLUE);
                
                


                aniSpriteBody.position = new Vector2f(-50, Settings.WindowSize.Y - 50);
                aniSpriteMouth.position = new Vector2f(-50, Settings.WindowSize.Y - 50);
                aniSpriteEye.position = new Vector2f(-50, Settings.WindowSize.Y - 50);

                aniSpriteBody.scale = 0.6f;
                aniSpriteMouth.scale = 0.6f;
                aniSpriteEye.scale = 0.6f;



            }

            if (KInput.IsClicked(SFML.Window.Keyboard.Key.Escape))
            {
                parent.SetGameState(new MainMenu());
            }
        }

        public override void Draw()
        {

            parent.window.Clear();


            parent.window.Draw(acaSprite);


            aniSpriteBody.Draw(parent.window);
            aniSpriteEye.Draw(parent.window);
            aniSpriteMouth.Draw(parent.window);

            aniSpriteBody2.Draw(parent.window);
            aniSpriteEye2.Draw(parent.window);
            aniSpriteMouth2.Draw(parent.window);


            
            parent.window.Draw(textKai);
            parent.window.Draw(textGerd);
            parent.window.Draw(textAcagamics);
            parent.window.Draw(aGameBy);
        }
    }
}
