﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Input
{
    public sealed class KeyboardKeyInfo : KeyInfo
    {
        private SFML.Window.Keyboard.Key key;

        public KeyboardKeyInfo(SFML.Window.Keyboard.Key key)
        {
            this.key = key;
        }


        protected override bool CurrentlyPressed()
        {
            return SFML.Window.Keyboard.IsKeyPressed(key);
        }
    }
}
