﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Input
{
    public sealed class MouseKeyInfo : KeyInfo
    {
        SFML.Window.Mouse.Button button;

        public MouseKeyInfo(SFML.Window.Mouse.Button button)
        {
            this.button = button;
        }


        protected override bool CurrentlyPressed()
        {
            return SFML.Window.Mouse.IsButtonPressed(button);
        }
    }
}
