﻿using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Components
{
    public class LinearMover : AThinker
    {
        Vector2f start;
        Vector2f direction;

        float speed;


        public LinearMover(Vector2f start, Vector2f dir, float speed)
        {
            this.start = start;
            this.direction = dir;
            this.speed = speed;
        }

        public override void Update()
        {
            this.Owner.Collider.Position = this.Owner.Collider.Position + direction * speed;

        }

        public override void Init()
        {
            this.Owner.Collider.Position = start;
            this.Owner.Collider.Direction = direction;
        }

    }
}
