﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Input
{
    public sealed class GamepadKeyInfo : KeyInfo
    {
        uint button;
        uint gamepadId;

        public GamepadKeyInfo(uint gamepadId, uint button)
        {
            this.button = button;
            this.gamepadId = gamepadId;
        }

        protected override bool CurrentlyPressed()
        {
            return SFML.Window.Joystick.IsButtonPressed(gamepadId, button);
        }
    }
}
