﻿using BobbleCrowd.GameStates;
using SFML.Graphics;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Message
{
    public abstract class AMessage
    {
        protected Game game;

        public AMessage(Game game)
        {
            this.game = game;
        }

        public bool HasFinished { get; set; }

        public bool Pauses { get; protected set; }


        public abstract void Update(GameTime gameTime, RenderTarget target);

        public abstract void Draw(GameTime gameTime, RenderTarget target);

        public abstract void Init(GameTime gameTime, RenderTarget target);

        public abstract void ShutDown(GameTime gameTime, RenderTarget target);


    }
}
