﻿using BobbleCrowd.GameStates;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Message
{
    public class EmptyMessage : AMessage
    {
        private static EmptyMessage instance;

        public static EmptyMessage Instance
        {
            get { if (instance == null) instance = new EmptyMessage(null); return instance; }
            private set { instance = value; }
        }

        private EmptyMessage(Game game) : base(game)
        {
            Pauses = false;
            HasFinished = true;
        }

        public override void Update(GameTime gameTime, SFML.Graphics.RenderTarget target)
        {
           
        }

        public override void Draw(GameTime gameTime, SFML.Graphics.RenderTarget target)
        {
            
        }

        public override void Init(GameTime gameTime, SFML.Graphics.RenderTarget target)
        {
            
        }

        public override void ShutDown(GameTime gameTime, SFML.Graphics.RenderTarget target)
        {
            
        }
    }
}
