﻿using SFML.Graphics;
using SFML.Window;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BobbleCrowd.Tiled
{
    /// <summary>
    /// Represents a tile or an decoration element read from Tiled.
    /// </summary>
    public class TileData
    {
        public Vector2f worldPos;

        public int id;

        public float rotation;


        public TileData(Vector2f pos, int id, float rotation)
        {
            this.worldPos = pos;

            this.id = id;

            this.rotation = rotation;
        }


        public TileData(int x, int y, int id, float rotation)
        {
            this.worldPos = new Vector2f(x, y);

            this.id = id;

            this.rotation = rotation;
        }

    }
}
